
function correlation(height1, height2, height3, height4, height5, height6, confidence11, confidence12, confidence13, confidence14, confidence15, confidence16, confidence21, confidence22, confidence23, confidence24, confidence25, confidence26)
{

//Variable for the causes
var numberOfCauses = 6; 
var nameCause = ['Food', 'Mosquitos', 'Water', 'Blood', 'Sewage', 'Rodents']; 
var H = [height1, height2, height3, height4, height5, height6]; 
var C1 = [confidence11, confidence12, confidence13, confidence14, confidence15, confidence16]; 
var C2 = [confidence21, confidence22, confidence23, confidence24, confidence25, confidence26]; 

var width = 600; 
var height = 600; 

var d_canvas = document.getElementById("sc"); 
var context = d_canvas.getContext("2d"); 



//CREATE A GRID
for (var x = 0.5; x < width; x += 10) { 
  context.moveTo(x, 0); 
  context.lineTo(x, height);   
} 
for (var y = 0.5; y < height; y += 10) { 
  context.moveTo(0, y); 
  context.lineTo(width, y);   
} 

context.strokeStyle = "#eee"; 
context.stroke(); 

var xAxis = height/2;
var xAxisLength = width-20;



context.beginPath(); 
//DRAW X AXIS
context.moveTo(0, xAxis); 
context.lineTo(xAxisLength, xAxis); 
//Draw twice to make sure the axis is visible
context.moveTo(0, xAxis); 
context.lineTo(xAxisLength, xAxis); 
//DRAW X ARROW
context.moveTo(xAxisLength-5, xAxis-5); 
context.lineTo(xAxisLength, xAxis); 
context.lineTo(xAxisLength-5, xAxis+5); 

var yAxisMargin = 30; 
var yAxisLength = 20;


//DRAW Y AXIS
context.moveTo(yAxisMargin, yAxisLength); 
context.lineTo(yAxisMargin, height); 
//Draw twice to make sure the axis is visible
context.moveTo(yAxisMargin, yAxisLength); 
context.lineTo(yAxisMargin, height); 


//DRAW Y ARROW
context.moveTo(yAxisMargin, yAxisLength); 
context.lineTo(yAxisMargin-5, yAxisLength+5); 
context.moveTo(yAxisMargin, yAxisLength); 
context.lineTo(yAxisMargin+5, yAxisLength+5); 

context.strokeStyle = "#000"; 
context.stroke(); 

//GRADE CHART FROM 1 TO -1
var numberOfGraduation = 10; 
var yCoordinateForGraduation = new Array(); 
var xCoordinateForGraduation = 10; 
var gradingValue = new Array(); 
var minGradingValue = -1;
var maxGradingValue = 1;
var distanceBetweenMinAndMaxGradingValue = Math.abs(minGradingValue - maxGradingValue);


//Define the Y coordinate and value for each graduation
for (var i=0, j=numberOfGraduation; i<numberOfGraduation; i++, j--)
{
yCoordinateForGraduation [i] = height -(i*(height-20))/numberOfGraduation; 
gradingValue [i] = minGradingValue + ((i*distanceBetweenMinAndMaxGradingValue)/numberOfGraduation); 
gradingValue [i] = Math.round(gradingValue [i]*10)/10
}

//Write the graduation on the bar chart: 
for (var i=0; i<numberOfGraduation; i++)
{
context.fillText(gradingValue [i] , xCoordinateForGraduation, yCoordinateForGraduation[i]);
}


//DRAW BAR AND CONFIDENCE INTERVAL
//final variable
var xMargin = 30; 
var widthBar = 30;
var widthConfidenceInterval = widthBar;




var yCoordinateForBar = new Array ();
var xCoordinateForBar = new Array ();


for (var i=0; i<numberOfCauses; i++)
{
yCoordinateForBar[i] = height/2;
xCoordinateForBar[i] = ((i+1)*(width/7)) - xMargin;
}

//Color Bar Chart
context.fillStyle = "#4D89F9";
//DRAW THE BAR
for (var i=0; i<numberOfCauses; i++)
{
var E = H[i]; 
E  = height-(((E+1)/2)*(height-yAxisLength));

	if (E<310)
	{
	//swap coordinate value and E
	E = Math.abs (yCoordinateForBar[i]-E);
	temp = E;
	E = yCoordinateForBar[i]; 
	yCoordinateForBar[i] = temp;
	yCoordinateForBar[i] = Math.abs (310 - yCoordinateForBar[i]); 
	E  = Math.abs(yCoordinateForBar[i]-E);
	context.fillRect(xCoordinateForBar[i], yCoordinateForBar[i], widthBar, E);
	}

	else
	{
	E = Math.abs (E-yCoordinateForBar[i]);
	context.fillRect(xCoordinateForBar[i], yCoordinateForBar[i], widthBar, E);
	}

}


//DRAW THE CONFIDENCE INTERVAL
/*
for (var i=0; i<numberOfCauses; i++)
{
context.fillRect(xCoordinateForBar[i], confidenceIntervalFrom, widthBar, 2);
context.fillRect(xCoordinateForBar[i], confidenceIntervalTo, widthBar, 2);
context.fillRect(xCoordinateForBar[i]+12, confidenceIntervalFrom, 4, heightConfidenceInterval);
}

*/


//test confidence interval 
context.fillStyle = "#F35";
for (var i=0; i<numberOfCauses; i++)
{
var confidenceIntervalFrom = C1[i]+1; 
var confidenceIntervalTo = C2[i]+1;
var ratioFrom = (confidenceIntervalFrom/distanceBetweenMinAndMaxGradingValue)*(height-yAxisLength);
ratioFrom = height - ratioFrom;
 
var ratioTo = (confidenceIntervalTo/distanceBetweenMinAndMaxGradingValue)*(height-yAxisLength); 
ratioTo = height - ratioTo;


//convert height
var heightConfidenceInterval = ratioTo-ratioFrom;

context.fillRect(xCoordinateForBar[i], ratioFrom, widthBar, 2);
context.fillRect(xCoordinateForBar[i], ratioTo, widthBar, 2);
context.fillRect(xCoordinateForBar[i]+12, ratioFrom, 4, heightConfidenceInterval);
}


//WRITE TITLE OF THE CHART
context.fillStyle = "#163861";
context.font = "bold 30px Arial"; 
context.fillText("Single Correlation", width/4, 30); 


//WRITE THE DIFFERENT CAUSES
context.font = "bold 15px Arial"; 
for (var i=0; i<numberOfCauses; i++)
{
context.fillText(nameCause[i], xCoordinateForBar[i]-10, yCoordinateForBar[i]+15);
}



}


function unionCorrelation(height1, height2, height3, height4, height5, height6, confidence11, confidence12, confidence13, confidence14, confidence15, confidence16, confidence21, confidence22, confidence23, confidence24, confidence25, confidence26)
{

//Variable for the causes
var numberOfCauses = 6; 
var nameCause = ['Food', 'Mosquitos', 'Water', 'Blood', 'Sewage', 'Rodents']; 
var H = [height1, height2, height3, height4, height5, height6]; 
var C1 = [confidence11, confidence12, confidence13, confidence14, confidence15, confidence16]; 
var C2 = [confidence21, confidence22, confidence23, confidence24, confidence25, confidence26]; 

var width = 600; 
var height = 600; 

var d_canvas = document.getElementById("uc"); 
var context = d_canvas.getContext("2d"); 



//CREATE A GRID
for (var x = 0.5; x < width; x += 10) { 
  context.moveTo(x, 0); 
  context.lineTo(x, height);   
} 
for (var y = 0.5; y < height; y += 10) { 
  context.moveTo(0, y); 
  context.lineTo(width, y);   
} 

context.strokeStyle = "#eee"; 
context.stroke(); 

var xAxis = height/2;
var xAxisLength = width-20;



context.beginPath(); 
//DRAW X AXIS
context.moveTo(0, xAxis); 
context.lineTo(xAxisLength, xAxis); 
//Draw twice to make sure the axis is visible
context.moveTo(0, xAxis); 
context.lineTo(xAxisLength, xAxis); 
//DRAW X ARROW
context.moveTo(xAxisLength-5, xAxis-5); 
context.lineTo(xAxisLength, xAxis); 
context.lineTo(xAxisLength-5, xAxis+5); 

var yAxisMargin = 30; 
var yAxisLength = 20;


//DRAW Y AXIS
context.moveTo(yAxisMargin, yAxisLength); 
context.lineTo(yAxisMargin, height); 
//Draw twice to make sure the axis is visible
context.moveTo(yAxisMargin, yAxisLength); 
context.lineTo(yAxisMargin, height); 


//DRAW Y ARROW
context.moveTo(yAxisMargin, yAxisLength); 
context.lineTo(yAxisMargin-5, yAxisLength+5); 
context.moveTo(yAxisMargin, yAxisLength); 
context.lineTo(yAxisMargin+5, yAxisLength+5); 

context.strokeStyle = "#000"; 
context.stroke(); 

//GRADE CHART FROM 1 TO -1
var numberOfGraduation = 10; 
var yCoordinateForGraduation = new Array(); 
var xCoordinateForGraduation = 10; 
var gradingValue = new Array(); 
var minGradingValue = -1;
var maxGradingValue = 1;
var distanceBetweenMinAndMaxGradingValue = Math.abs(minGradingValue - maxGradingValue);


//Define the Y coordinate and value for each graduation
for (var i=0, j=numberOfGraduation; i<numberOfGraduation; i++, j--)
{
yCoordinateForGraduation [i] = height -(i*(height-20))/numberOfGraduation; 
gradingValue [i] = minGradingValue + ((i*distanceBetweenMinAndMaxGradingValue)/numberOfGraduation); 
gradingValue [i] = Math.round(gradingValue [i]*10)/10
}

//Write the graduation on the bar chart: 
for (var i=0; i<numberOfGraduation; i++)
{
context.fillText(gradingValue [i] , xCoordinateForGraduation, yCoordinateForGraduation[i]);
}


//DRAW BAR AND CONFIDENCE INTERVAL
//final variable
var xMargin = 30; 
var widthBar = 30;
var widthConfidenceInterval = widthBar;




var yCoordinateForBar = new Array ();
var xCoordinateForBar = new Array ();


for (var i=0; i<numberOfCauses; i++)
{
yCoordinateForBar[i] = height/2;
xCoordinateForBar[i] = ((i+1)*(width/7)) - xMargin;
}

//Color Bar Chart
context.fillStyle = "#4D89F9";
//DRAW THE BAR
for (var i=0; i<numberOfCauses; i++)
{
var E = H[i]; 
E  = height-(((E+1)/2)*(height-yAxisLength));

	if (E<310)
	{
	//swap coordinate value and E
	E = Math.abs (yCoordinateForBar[i]-E);
	temp = E;
	E = yCoordinateForBar[i]; 
	yCoordinateForBar[i] = temp;
	yCoordinateForBar[i] = Math.abs (310 - yCoordinateForBar[i]); 
	E  = Math.abs(yCoordinateForBar[i]-E);
	context.fillRect(xCoordinateForBar[i], yCoordinateForBar[i], widthBar, E);
	}

	else
	{
	E = Math.abs (E-yCoordinateForBar[i]);
	context.fillRect(xCoordinateForBar[i], yCoordinateForBar[i], widthBar, E);
	}

}


//DRAW THE CONFIDENCE INTERVAL
/*
for (var i=0; i<numberOfCauses; i++)
{
context.fillRect(xCoordinateForBar[i], confidenceIntervalFrom, widthBar, 2);
context.fillRect(xCoordinateForBar[i], confidenceIntervalTo, widthBar, 2);
context.fillRect(xCoordinateForBar[i]+12, confidenceIntervalFrom, 4, heightConfidenceInterval);
}

*/


//test confidence interval 
context.fillStyle = "#F35";
for (var i=0; i<numberOfCauses; i++)
{
var confidenceIntervalFrom = C1[i]+1; 
var confidenceIntervalTo = C2[i]+1;
var ratioFrom = (confidenceIntervalFrom/distanceBetweenMinAndMaxGradingValue)*(height-yAxisLength);
ratioFrom = height - ratioFrom;
 
var ratioTo = (confidenceIntervalTo/distanceBetweenMinAndMaxGradingValue)*(height-yAxisLength); 
ratioTo = height - ratioTo;


//convert height
var heightConfidenceInterval = ratioTo-ratioFrom;

context.fillRect(xCoordinateForBar[i], ratioFrom, widthBar, 2);
context.fillRect(xCoordinateForBar[i], ratioTo, widthBar, 2);
context.fillRect(xCoordinateForBar[i]+12, ratioFrom, 4, heightConfidenceInterval);
}


//WRITE TITLE OF THE CHART
context.fillStyle = "#163861";
context.font = "bold 30px Arial"; 
context.fillText("Union Correlation", width/4, 30); 


//WRITE THE DIFFERENT CAUSES
context.font = "bold 15px Arial"; 
for (var i=0; i<numberOfCauses; i++)
{
context.fillText(nameCause[i], xCoordinateForBar[i]-10, yCoordinateForBar[i]+15);

}



}


function legend()
{
    var width = 200; 
    var height = 200; 
  var b_canvas = document.getElementById("b"); 
  var context = b_canvas.getContext("2d"); 
 context.fillStyle = "#4D89F9";
 context.fillRect(5, 5, width/4, height/3); 
 
context.fillStyle = "#163861";
context.font = " 15px Arial"; 
context.fillText("Correlation", (width/2)-10, (height)/6 ); 
context.font = " 12px Arial"; 

context.fillText("of a cause over", (width/2)-25, ((height)/6)+20 ); 
context.fillText("the symptoms showed", (width/2)-30, ((height)/6)+40 ); 




context.fillStyle = "#F35";
context.fillRect(5, ((2*height)/3)+5, width/4, 2); 
context.fillRect(5, height-5, width/4, 2); 
context.fillRect((5+(width/4))/2, ((2*height)/3)+5, 4, height-5 - (((2*height)/3)+5) ); 

context.fillStyle = "#163861";
context.font = " 15px Arial"; 
context.fillText("Confidence interval", width/3, (4*height)/5 ); 


}








